diff --git a/jerry-core/parser/js/js-parser-statm.c b/jerry-core/parser/js/js-parser-statm.c
index c5ba6124f7..bf01bf9122 100644
--- a/jerry-core/parser/js/js-parser-statm.c
+++ b/jerry-core/parser/js/js-parser-statm.c
@@ -1558,6 +1558,11 @@ parser_parse_for_statement_start (parser_context_t *context_p) /**< context */
       {
         if (context_p->next_scanner_info_p->source_p == source_p)
         {
+          if (context_p->next_scanner_info_p->type == SCANNER_TYPE_LET_EXPRESSION)
+          {
+            JERRY_ASSERT (context_p->status_flags & PARSER_IS_STRICT);
+            parser_raise_error (context_p, PARSER_ERR_STRICT_IDENT_NOT_ALLOWED);
+          }
           parser_push_block_context (context_p, true);
         }
         /* FALLTHRU */
diff --git a/tests/jerry/fail/regression-test-issue-4190-4195.js b/tests/jerry/fail/regression-test-issue-4190-4195.js
new file mode 100644
index 0000000000..4f220b6c6c
--- /dev/null
+++ b/tests/jerry/fail/regression-test-issue-4190-4195.js
@@ -0,0 +1,16 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+export default a;
+for (let
